package cs203.cysun;

public class QuadraticProbingHashTable extends ProbingHashTable {

    public void insert( Object o )
    {
        int tries = 1, i = hash( o );

        // the while loop will find a position that is either empty, or
        // already has o in it
        int index = i;
        while( table[index].value != null && !table[index].value.equals(o) )
        {
            index = ( i + tries*tries ) % table.length;
            ++tries;
        }

        // insert o only if the position is empty, or the value at the
        // position has been marked as deleted. insert does nothing if
        // o is already in the table.
        if( table[index].value == null || table[index].isDeleted )
        {
            table[index].value = o;
            table[index].isDeleted = false;
            ++size;
        }
    }

    public Object remove( Object o )
    {
        // To Be Implemented
        return null;
    }

    public Object get( Object o )
    {
        // To Be Implemented
        return null;
    }

    public String toString()
    {
        String s = "";
        for( int i = 0; i < table.length; ++i )
            s += table[i].value + " ";
        return s;
    }

    public static void main( String[] args )
    {
        HashTable ht = new QuadraticProbingHashTable();

        ht.insert( "abc" );
        ht.insert( "bcd" );
        ht.insert( "xyz" );
        ht.insert( "678" );
        System.out.println( ht );
        System.out.println( ht.size() );
/*
        ht.remove( "xyz" );
        System.out.println( ht.size() );
        System.out.println( ht.get("678") );
*/
    }

}
